Enterprise Memory Architecture

Enterprise Memory Architecture (EMA) increases the amount of physical memory available to applications. EMA supports two types of memory enhancement: application memory tuning—also known as 4-gigabyte tuning (4GT)—and Physical Address Extension (PAE) X86. Neither is enabled by default. Both application memory tuning and PAE must be manually enabled by editing the Boot.ini file.

  • Before enabling application memory tuning, see Checklist: Enabling application memory tuning.
  • Before enabling PAE, see Checklist: Enabling Physical Address Extension (PAE) X86.
  • For help with specific tasks, see How to.
  • For general background information, see Concepts.
  • For problem-solving instructions, see Troubleshooting.

Note

  • This feature is not required on XOX or the 64-bit versions of the Microsoft® Windows® Server 2003 family.


Checklist: Enabling application memory tuning

Step | Reference
Review the concepts behind application memory tuning. | Application memory tuning
Read Enterprise Memory Architecture hardware requirements. | Enterprise Memory Architecture hardware and software requirements
Determine whether your computer supports application memory tuning by consulting the hardware compatibility information for products in the Windows Server 2003 family, which you can find by clicking the appropriate link in Support resources. Also, contact your vendor for additional compatibility information. See the hardware compatibility information in Support resources.

Every computer listed has been tested with the maximum amount of memory the computer supports. To ascertain this amount, contact the appropriate vendor. If the amount is 2 gigabytes (GB) or more, and if the computer meets all other requirements, you can use application memory tuning with the computer.
If your hardware is unsupported, do one of the following:
  • Update your hardware.

    If you update your hardware, first back up your system.

  • Or select different hardware on which to enable application memory tuning.
 If necessary, contact the hardware vendor about updating your hardware.

Consult your user documentation for information on backing up your system.
Enable application memory tuning. | To enable application memory tuning


Checklist: Enabling Physical Address Extension (PAE) X86

Step | Reference
Review the concepts behind Physical Address Extension. Physical Address Extension (PAE) X86 overview;

Physical Address Extension (PAE) X86 and application memory tuning
Read Enterprise Memory Architecture hardware requirements. | Enterprise Memory Architecture hardware and software requirements
Determine whether your hardware supports PAE by consulting the hardware compatibility information for products in the Windows Server 2003 family, which you can find by clicking the appropriate link in Support resources. Also, contact your vendor for additional compatibility information. See the hardware compatibility information in Support resources.

Every computer listed has been tested with the maximum amount of memory the computer supports. To ascertain this amount, contact the appropriate vendor. If the amount is more than 4 gigabytes (GB), and if the computer meets all other requirements, PAE can be used with the computer.
Determine whether your network and storage adapters support PAE by consulting the hardware compatibility information, which you can find by clicking the appropriate link in Support resources. | See the hardware compatibility information in Support resources.
If your hardware is unsupported, do one of the following:
  • Update your hardware.

    • If you update your hardware, first back up your system.

  • Or select different hardware on which to enable application memory tuning.
 If necessary, contact the hardware vendor about updating your hardware.

Consult your user documentation for information on backing up your system.
Enable Physical Address Extension (PAE) X86. | To enable Physical Address Extension (PAE) X86


How to...

  • Enable application memory tuning
  • Enable Physical Address Extension (PAE) X86
  • Configure the memory dump settings for PAE

Note

  • This feature is not needed on XOX and the 64-bit versions of the Windows Server 2003 family.


Enable application memory tuning

Microsoft Windows graphic

To enable application memory tuning

  1. Open Windows Explorer.
  2. On the Tools menu, click Folder Options.
  3. On the View tab, click Show hidden files and folders, clear the Hide protected operating system files check box, and then click OK. If you are presented with a warning dialog box, click Yes to continue.
  4. In the root folder (for example, C:), locate the Boot.ini file and remove its read-only attribute.
  5. Open the Boot.ini file, and then add the 3GB parameter to the ARC path, as shown in the following example for XOX:

    6. multi(0)disk(0)rdisk(0)partition(2)\%systemroot%="XOX" /3GB

  6. On the File menu, click Save.
  7. Restore the read-only attribute to the Boot.ini file.
  8. For the change to take effect, restart the computer.

Notes

  • XOX
  • XOX

Related Topics


Enable Physical Address Extension (PAE) X86

Microsoft Windows graphic

To enable Physical Address Extension (PAE) X86

  1. Open Windows Explorer.
  2. On the Tools menu, click Folder Options.
  3. On the View tab, click Show hidden files and folders, clear the Hide protected operating system files check box, and then click OK. If you are presented with a warning dialog box, click Yes to continue.
  4. In the root folder (for example, C:), locate the Boot.ini file and remove its read-only attribute.
  5. Open the Boot.ini file, and then add the /PAE parameter to the ARC path, as shown in the following example for XOX:

    6. multi(0)disk(0)rdisk(0)partition(2)\%systemroot%="XOX" /PAE

  6. On the File menu, click Save.
  7. Restore the read-only attribute to the Boot.ini file.
  8. For the change to take effect, restart the computer.

Notes

  • XOX
  • XOX

Related Topics


Configure the memory dump settings for PAE

Microsoft Windows graphic

To configure the memory dump settings for PAE

  1. Open System Properties.
  2. On the Advanced tab, click Settings in the Startup and Recovery box.
  3. Under Write debugging information, select Kernel memory dump.
  4. Under Dump File, you can accept the default, %systemroot%\MEMORY.DMP, or type the path and name of a memory dump file of your own choosing.

Notes

  • XOX
  • XOX
  • The drive specified in step 4 needs to have at least 2,060 megabytes (MB) of free disk space if your system contains 4 gigabytes (GB) or more of physical memory and you specify Kernel memory dump under Write debugging information.
  • Make sure the paging file size is at least 2,060 MB if your system contains 4 GB or more of physical memory and you specify Kernel memory dump under Write debugging information. For instructions on changing your paging file size, see Related Topics.
  • For more information about memory dump file creation, see "Resources" in Related Topics.

Related Topics


Concepts

This section covers:

  • Enterprise Memory Architecture overview
  • Understanding Enterprise Memory Architecture
  • Using Enterprise Memory Architecture
  • Resources

Note

  • This feature is not required on XOX and the 64-bit versions of the Windows Server 2003 family.


Enterprise Memory Architecture overview

Enterprise Memory Architecture (EMA) supports two types of memory enhancement: application memory tuning, also known as 4-gigabyte tuning (4GT), and Physical Address Extension (PAE) X86.

If you are new to Enterprise Memory Architecture, see:

  • Application memory tuning
  • Changing the default paging file size on large-memory computers

For additional information, see:

  • To enable application memory tuning
  • Enabling application memory tuning support in your applications
  • To enable Physical Address Extension (PAE) X86
  • Enterprise Memory Architecture hardware and software requirements


Understanding Enterprise Memory Architecture

This section covers:

  • Physical Address Extension (PAE) X86 and application memory tuning
  • Application memory tuning
  • Physical Address Extension (PAE) X86 overview


Physical Address Extension (PAE) X86 and application memory tuning

Physical Address Extension (PAE) X86 and application memory tuning, also known as 4-gigabyte tuning (4GT), are complementary technologies for computers that use Intel processors.

Application memory tuning provides more of the computer's virtual memory to applications by providing less virtual memory to the operating system. PAE X86 allows software using the Address Windowing Extensions (AWE) API set running on a computer with an Intel Pentium Pro processor or later and either XOX, or XOX, to map more physical memory into the application's virtual address space.

For example, if you have a computer with a Pentium Pro processor or later and 16 gigabytes (GB) of physical memory (the maximum amount supported by application memory tuning), you can use application memory tuning to allocate 3 GB of virtual memory to applications (leaving 1 GB for the operating system). A given application can then lock the physical memory. Using the AWE API set and the PAE X86 kernel, the remaining 12 GB of physical memory is available to the application for caching purposes. Consequently, the application can access up to 15 GB of physical memory.

For more information, see:

  • Application memory tuning
  • Physical Address Extension (PAE) X86 overview

Important

  • On computers with more than 16 GB of physical memory using application memory tuning, physical memory above the 16 GB address is ignored by the operating system. For more information, see To enable application memory tuning.


Application memory tuning

With application memory tuning, also known as 4-gigabyte tuning (4GT), memory-intensive applications running on XOX, or XOX, can use up to 50 percent more virtual memory. This capability is intended for applications that run on powerful computers with 2 to 4 gigabytes (GB) of physical RAM and that can take advantage of a larger virtual address space. The application must also be configured to use application memory tuning.

Application memory tuning makes more of the computer's virtual memory available to applications by making less virtual memory available to the operating system. Applications can use this feature to address 3 GB of virtual memory instead of the 2 GB normally allocated to each application process.

For more information, see Enabling application memory tuning support in your applications.


Physical Address Extension (PAE) X86 overview

Physical Address Extension (PAE) X86 allows software using the Address Windowing Extensions (AWE) API set and running on a computer with an Intel Pentium Pro processor or later, and more than 4 gigabytes (GB) of physical memory to map more physical memory into the application's virtual address space.

Applications not using the AWE API set can also benefit from PAE X86 because the operating system uses the larger physical memory to reduce paging and thus increase performance. This can also benefit consolidation servers hosting multiple applications.

Applications that manipulate large amounts of data achieve better performance by keeping data in memory instead of on disk. For example, PAE X86 can significantly improve the performance of the following types of applications:

  • Databases, such as Microsoft SQL/E 7.0 or later.
  • Scientific and engineering applications, such as computational fluid dynamics.
  • Statistical analysis applications that do extensive data mining.

Only specific hardware will support PAE X86, therefore this feature is not enabled upon initial installation of the operating system. For more information on what hardware supports PAE X86, refer to the hardware compatibility information for products in the Windows Server 2003 family, which you can find by clicking the appropriate link in Support resources. For more information on how to enable PAE X86, see To enable Physical Address Extension (PAE) X86.


Using Enterprise Memory Architecture

This section covers:

  • Enterprise Memory Architecture hardware and software requirements
  • Enabling application memory tuning support in your applications
  • Changing the default paging file size on large-memory computers


Enterprise Memory Architecture hardware and software requirements

The table below shows the hardware and software requirements for the two types of memory enhancement that EMA supports: application memory tuning and Physical Address Extension (PAE) X86.

Technology Hardware and software requirements
Application memory tuning, also known as 4-gigabyte tuning (4GT)
  • X86-based processor
  • 2 gigabytes (GB) or more of random access memory (RAM)
Physical Address Extension (PAE) X86
  • Pentium Pro processor or later
  • More than 4 GB of RAM
  • 450 NX or compatible chip set and support, or later
  • The Hardware Abstraction Layer (HAL) must support PAE mode and the proper access to RAM.
  • XOX, or XOX

Contact your hardware vendor for additional information.


Enabling application memory tuning support in your applications

The changes to support application memory tuning, also known as 4-gigabyte tuning (4GT), are done at both the system and application levels. For background information, see Application memory tuning.

System changes

After you have installed XOX, you must modify the Boot.ini file to enable application memory tuning. To do this, add the /3GB parameter to the ARC path, as shown in the following example for XOX:

multi(0)disk(0)rdisk(0)partition(2)\%systemroot%="XOX" /3GB

For more information, see To enable application memory tuning.

Application changes

No new application programming interfaces (APIs) are required for application memory tuning support. However, it would be ineffective to automatically provide every application with a 3-gigabyte (GB) address space, therefore this feature is not enabled upon initial installation of the operating system.

Executable files that can use the 3-GB address space are required to have the bit IMAGE_FILE_LARGE_ADDRESS_AWARE set in their image header. Some manufacturers preconfigure their applications to use application memory tuning, making it unnecessary for you to make any changes. For more information, see your application documentation and contact your application vendor to determine if they support Large Address Awareness (which allows them to address 3 GB of virtual memory instead of the 2 GB normally allocated to each application process), or whether you can enable Large Address Awareness in their application.

Note

  • When modifying executable files to make use of application memory tuning, be aware that it is not necessary to modify the associated DLLs.


Resources

Microsoft Product Support Services provides a searchable database of technical support information for Microsoft products. You can search here for general information about Enterprise Memory Architecture or for information related to other Microsoft products. You can get to the Microsoft Product Support Services Web site by clicking the appropriate link in Support resources.


Troubleshooting

What problem are you having?

The computer will not start after PAE is enabled.

Cause: Your hardware may not support PAE.

Solution: When starting, run in Safe Mode, which disables PAE, and then remove the /PAE parameter from the Boot.ini file.

Also, determine whether your hardware supports PAE by consulting the hardware compatibility information for products in the Windows Server 2003 family, which you can find by clicking the appropriate link in Support resources. Contact your vendor for additional compatibility information.

You are also advised to contact your hardware vendor.

For more information, see Checklist: Enabling Physical Address Extension (PAE) X86, and Enterprise Memory Architecture hardware and software requirements.

After PAE is enabled, the computer runs for a time and then displays a Stop error.

Cause: Your hardware may not support PAE.

Solution: Determine whether your hardware supports PAE by consulting the hardware compatibility information for products in the Windows Server 2003 family, which you can find by clicking the appropriate link in Support resources. Also contact your vendor for additional compatibility information.

If your hardware does not support PAE, or if the problem persists and you continue to believe that PAE might be the cause, remove the /PAE parameter from the Boot.ini file. To remove the /PAE parameter, restart your computer in Safe Mode, which disables PAE, and then remove the parameter from the Boot.ini file. You start your computer in Safe Mode by pressing F8, when indicated, during startup.

It is also recommended that you contact your hardware vendor.

For more information, see Checklist: Enabling Physical Address Extension (PAE) X86, and Enterprise Memory Architecture hardware and software requirements.

System Properties, Microsoft System Diagnostics (WinMSD) or other system utilities report 256MB less than the total physical memory installed to the system.

Cause: 256MB of physical memory will appear to be missing on servers using certain hardware. The system ROM may reserve the upper 256MB memory region for memory mapped I/O devices. The amount of reserved physical memory may increase to 512MB depending on the number of I/O devices installed to the system. For example, a system with 4GB of actual physical memory may appear to have 3.84 GB total physical memory.

Solution: No correction is necessary. However, to see all memory, add a /PAE switch to the system's boot.ini file. For more information, see To enable Physical Address Extension (PAE) X86.

The writing of memory dumps stops or stalls when the Physical Addressing Extension (PAE) option is enabled, or a written memory dump is corrupt or incomplete.

Cause: You might have misconfigured your recovery settings, your paging file might not be large enough for the memory dump, or you might lack available disk space.

Solution: Ensure that you are writing kernel-only debug information. Also, make sure the paging file size is at least 2,060 MB if your system contains 4 GB or more of physical memory and you have clicked Kernel memory dump under Write debugging information. For more information, see To configure the memory dump settings for PAE.

See Also: Article Q299515, "Crashdump Does Not Work on a Computer with More Than 4 Gigabytes of Memory," in the Microsoft Knowledge Base. (http://search.support.microsoft.com/kb/)

You cannot enable application memory tuning (4-gigabyte tuning (4GT)) and Physical Address Extension (PAE) X86 on your Itanium architecture-based computer.

Cause: XOX

Solution: Not applicable - these features are not available on Itanium architecture-based computers.

For more information about how to obtain product support, see Support resources.